<?php

/**
*
* @copyright (c) 2011 Laf Innovative, Ltd.
* @license http://www.opensource.org/licenses/mit-license.php MIT License
* 
*/

define('ADP_INSTALL', true);

require_once('functions.php');

if(!file_exists("database.php") || isset($_POST['action'])){

	if(isset($_POST['action']) && $_POST['action'] == 'install'){

		$installer = _adp_installer();

	}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>ADP Installer</title>
<!-- meta tags -->
<meta name="robots" content="NOINDEX,FOLLOW" />
<!-- style -->
<style type="text/css">
body{
font-family:Arial, Helvetica, sans-serif;
font-size:1.0em;
}
div#wrap{
font-size:0.8em;
margin:15px auto 0 auto;
width:500px;
}
div#explanation{
margin:15px;
padding:5px;
border:1px dotted #990000;
}
div#footer{
font-size:0.8em;
text-align:center;
border-top:1px solid #000;
padding:5px;
}
h1{
text-align:center;
}
fieldset{
width:150px;
margin:0 auto;
border:none;
}
.strong{
font-weight:bold;
}
.green{
color:#339900;
}
.red{
color:#990000;
}
.right{
text-align:right;
}
.center{
text-align:center;
}
</style>
</head>
<body>
<div id="wrap">
	<h1>Astanda Directory Project</h1>

<?php

	if(isset($installer)){

		if($installer['status'] === true){

?>

	<p>Congratulations! ADP v<?php echo ADP_VER; ?> has successfully been installed!</p>
	<p class="strong">Please remove the following files:</p>
	<ol>
		<li>./admin/install.php</li>
		<li>./admin/update.php</li>
		<li>./INSTALL.txt</li>
	</ol>
	<div id="explanation">
		<p class="strong">The following tables have been created:</p>
		<ol>

<?php

			foreach($installer['information'] as $v){

?>

			<li><?php echo $v; ?></li>

<?php

			}

?>

		</ol>
	</div>
	<p class="center">Please <a href="index.php?adp=config&action=password&pwd=setup">set up your admin username and password</a> if you have not done so already!</p>
<?php

		}
		else{

?>

	<p>This is the install script for ADP v<?php echo ADP_VER; ?>.</p>
	<p class="strong">Minimal Server Requirements:</p>
	<ul>
		<li>UNIX Based OS</li>
		<li>Apache 1.3.37+</li>
		<li>MySQL 4.1.21+</li>
		<li>PHP 4.4.3+ with Sockets Enabled and Safe Mode Turned Off</li>
	</ul>
	<form action="install.php" method="POST"><input type="hidden" name="action" value="install">
		<p>Enter the MySQL database information that you will use with ADP:</p>
		<p class="strong center red">ERROR: Check that the below settings are correct.</p>
		<fieldset>
			<p><label for="database" class="strong">Database:</label><br/>
			<input name="database" id="database" value="<?php echo $_POST['database']; ?>" type="text" /></p>
			<p><label for="mysql_user" class="strong">Username:</label><br />
			<input name="mysql_user" id="mysql_user" value="<?php echo $_POST['mysql_user']; ?>" type="text" /></p>
			<p><label for="mysql_password" class="strong">Password:</label><br />
			<input name="mysql_password" id="mysql_password" value="<?php echo $_POST['mysql_password']; ?>" type="text" /></p>
			<p><label for="mysql_host" class="strong">Host:</label><br />
			<input name="mysql_host" id="mysql_host" value="<?php echo (isset($_POST['mysql_host'])) ? $_POST['mysql_host'] : 'localhost'; ?>" type="text" /></p>
		</fieldset>
		<p class="strong center">You must agree to our <a href="https://lafinnovative.com/astanda-directory-project/">Licensing Terms</a> in order to install and use this software.</p>
		<p class="right"><input type="submit" value="Setup Now &raquo;"></p>
	</form>


<?php

		}

	}
	else{

?>

	<p>This is the install script for ADP v<?php echo ADP_VER; ?>.</p>
	<p class="strong">Minimal Server Requirements:</p>
	<ul>
		<li>UNIX Based OS</li>
		<li>Apache 1.3.37+</li>
		<li>MySQL 4.1.21+</li>
		<li>PHP 4.4.3+ with Sockets Enabled and Safe Mode Turned Off</li>
	</ul>
	<form action="install.php" method="POST"><input type="hidden" name="action" value="install">
		<p>Enter the MySQL database information that you will use with ADP:</p>
		<fieldset>
			<p><label for="database" class="strong">Database:</label><br/>
			<input name="database" id="database" value="<?php echo $_POST['database']; ?>" type="text" /></p>
			<p><label for="mysql_user" class="strong">Username:</label><br />
			<input name="mysql_user" id="mysql_user" value="<?php echo $_POST['mysql_user']; ?>" type="text" /></p>
			<p><label for="mysql_password" class="strong">Password:</label><br />
			<input name="mysql_password" id="mysql_password" value="<?php echo $_POST['mysql_password']; ?>" type="text" /></p>
			<p><label for="mysql_host" class="strong">Host:</label><br />
			<input name="mysql_host" id="mysql_host" value="<?php echo (isset($_POST['mysql_host'])) ? $_POST['mysql_host'] : 'localhost'; ?>" type="text" /></p>
		</fieldset>
		<p class="strong center">You must agree to our <a href="http://lafinnovative.com/astanda-directory-project/">Licensing Terms</a> in order to install and use this software.</p>
		<p class="right"><input type="submit" value="Setup Now &raquo;"></p>
	</form>

<?php

	}

?>
<div id="footer">&copy; <?php echo date('Y'); ?> <a href="http://lafinnovative.com">Laf Innovative, Ltd.</a>. All Rights Reserved.</div>
</div>
</body>
</html>

<?php

}
else{

	//ADP is probably installed if the database.php file exists.
	//So we will redirect to the update page.
	header('Location:./update.php');
	exit();

}

function _adp_installer(){

	$directories = array('fonts', 'images', 'smarty/cache', 'smarty/configs', 'smarty/internals', 'smarty/plugins', 'smarty/templates_c', 'templates');

	foreach($directories as $d){

		if(is_dir($d)){

			@chmod($d, 0777);

		}

	}

	if(@touch("database.php")){

		@chmod("database.php",0777);

		$fhandle = @fopen("database.php","wb");

		if($fhandle){

			fwrite($fhandle, "<?php\n\n");
			fwrite($fhandle, "$" . "database = \"" . $_POST['database'] . "\";\n");
			fwrite($fhandle, "$" . "mysql_user = \"" . $_POST['mysql_user'] . "\";\n");
			fwrite($fhandle, "$" . "mysql_password = \"" . $_POST['mysql_password'] . "\";\n");
			fwrite($fhandle, "$" . "mysql_host = \"" . $_POST['mysql_host'] . "\";\n");
			fwrite($fhandle, "$" . "success = mysql_pconnect ($" . "mysql_host, $" . "mysql_user, $" . "mysql_password);\n");
			fwrite($fhandle, "if (!$" . "success) { die (\"<b>Cannot connect to database, check if username, password and host are correct.</b>\"); }\n");
			fwrite($fhandle, "$"."success = mysql_select_db ($" . "database);\n");
			fwrite($fhandle, "if (!$" . "success) { print \"<b>Cannot choose database, check if database name is correct.\"; die(); }\n");
			fwrite($fhandle, "\n?>");
			fclose($fhandle);

		}
		else{

			//Display the output for the user to create their own file.

		}

	}
	else{

		//Display the output for the user to create their own file.

	}

	if(@mysql_pconnect($_POST['mysql_host'], $_POST['mysql_user'], $_POST['mysql_password'])){

		if(@mysql_select_db($_POST['database'])){

			$sql = "CREATE TABLE bad_keywords (
						id int(11) NOT NULL auto_increment,
						keyword text collate utf8_unicode_ci NOT NULL,
						PRIMARY KEY  (id)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";

			mysql_query($sql);

			$sql = "CREATE TABLE banned (
						id int(11) NOT NULL auto_increment,
						domain text collate utf8_unicode_ci NOT NULL,
						PRIMARY KEY  (id)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";

			mysql_query($sql);

			$sql = "CREATE TABLE categories (
						id int(11) NOT NULL auto_increment,
						parent int(11) default NULL,
						title text collate utf8_unicode_ci,
						path text collate utf8_unicode_ci,
						description text collate utf8_unicode_ci,
						keywords text collate utf8_unicode_ci,
						date date NOT NULL default '0000-00-00',
						PRIMARY KEY  (id)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";

			mysql_query($sql);

			$sql = "CREATE TABLE IF NOT EXISTS config (
						 config_id bigint(20) unsigned NOT NULL auto_increment,
						 site_id int(11) NOT NULL default '0',
						 option_name varchar(64) character set utf8 collate utf8_bin NOT NULL,
						 option_value longtext character set utf8 collate utf8_bin,
						 autoload tinyint(1) NOT NULL default '1',
						PRIMARY KEY (config_id,site_id,option_name),
						UNIQUE KEY option_name (option_name)
						) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";

			mysql_query($sql);

			$sql = "INSERT INTO config (config_id, site_id, option_name, option_value, autoload) VALUES
						(1, 0, 'version', '" . mysql_real_escape_string(ADP_VER) . "', 1),
						(2, 0, 'title', 'Astanda Directory Project', 1),
						(3, 0, 'description', '', 1),
						(4, 0, 'keywords', '', 1),
						(5, 0, 'email', 'admin@localhost', 1),
						(6, 0, 'admin', 'ADP Admin', 1),
						(7, 0, 'recip_regex', '/<a(\s*)href=\"http:\/\/(.*)" . mysql_real_escape_string($_SERVER['SERVER_NAME']) . "(.*)\">([^\n]+)<\/a>/', 1),
						(8, 0, 'recip_required', '0', 1),
						(9, 0, 'captcha', '0', 1),
						(10, 0, 'new_links', '10', 1),
						(11, 0, 'recip_links', '10', 1),
						(12, 0, 'sub_cat_num', '4', 1),
						(13, 0, 'num_links', '10', 1),
						(14, 0, 'num_pages', '20', 1),
						(15, 0, 'chars_title', '100', 1),
						(16, 0, 'chars_desc', '500', 1),
						(17, 0, 'addurl_gpr', '0', 1),
						(18, 0, 'spider_FollowMode', '2', 1),
						(19, 0, 'spider_FollowMatch', '', 1),
						(20, 0, 'spider_NonFollowMatch', '/.(jpg|jpeg|gif|png|bmp)$/ i', 1),
						(21, 0, 'spider_FollowRedirects', '1', 1),
						(22, 0, 'spider_FollowRedirectsTillContent', '1', 1),
						(23, 0, 'spider_ReceiveContentType', '/text/html/', 1),
						(24, 0, 'spider_PageLimit', '100', 1),
						(25, 0, 'spider_TrafficLimit', '5000', 1),
						(26, 0, 'spider_ContentSizeLimit', '100', 1),
						(27, 0, 'spider_ConnectionTimeout', '60', 1),
						(28, 0, 'spider_StreamTimeout', '60', 1),
						(29, 0, 'spider_CookieHandling', '1', 1),
						(30, 0, 'spider_UserAgent', 'Mozilla/5.0 (compatible; ADP; +http://" . mysql_real_escape_string($_SERVER['SERVER_NAME']) . ")', 1),
						(31, 0, 'spider_TitleMax', '100', 1),
						(32, 0, 'spider_DescriptionMax', '10000', 1),
						(33, 0, 'spider_DiplayContent', '0', 1),
						(34, 0, 'spider_Untitled', 'Untitled', 1),
						(35, 0, 'spider_pause', '0', 1),
						(36, 0, 'spider_delete', '0', 1),
						(37, 0, 'admin_limit', '30', 1),
						(38, 0, 'admin_set_time_limit', '0', 1),
						(39, 0, 'admin_stats', '0', 1),
						(40, 0, 'admin_gpr', '6', 1),
						(41, 0, 'admin_dmoz_check', '1', 1),
						(42, 0, 'admin_count_pages', '0', 1),
						(43, 0, 'file_gsm', 'sitemaps.xml', 1),
						(44, 0, 'file_static', 'index', 1),
						(45, 0, 'file_ext', 'html', 1),
						(46, 0, 'chmod', '777', 1),
						(47, 0, 'search_log', '1', 1),
						(48, 0, 'version_check', '" . mysql_real_escape_string(serialize(array('latest_version'=>ADP_VER, 'last_check'=>0))) . "', 1),
						(49, 0, 'url', '" . mysql_real_escape_string($_SERVER['SERVER_NAME']) . "', 1);";

			mysql_query($sql);

			$sql = "CREATE TABLE links (
						id bigint(20) unsigned NOT NULL auto_increment,
						url text collate utf8_unicode_ci,
						title text collate utf8_unicode_ci,
						description text collate utf8_unicode_ci,
						date date NOT NULL default '0000-00-00',
						recip tinyint(1) NOT NULL default '0',
						gpr tinyint(2) NOT NULL default '0',
						category_id int(11) NOT NULL default '0',
						visible tinyint(1) NOT NULL default '1',
						email tinytext collate utf8_unicode_ci NOT NULL,
						PRIMARY KEY  (id),
						FULLTEXT KEY links (url,title,description)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";

			mysql_query($sql);

			$sql = "CREATE TABLE new_links (
						id int(11) NOT NULL auto_increment,
						url text collate utf8_unicode_ci NOT NULL,
						title text collate utf8_unicode_ci NOT NULL,
						description text collate utf8_unicode_ci NOT NULL,
						email tinytext collate utf8_unicode_ci NOT NULL,
						category int(11) NOT NULL default '0',
						PRIMARY KEY  (id)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";

			mysql_query($sql);

			$sql = "CREATE TABLE pages (
						id bigint(20) unsigned NOT NULL auto_increment,
						link_id int(11) NOT NULL default '0',
						url text collate utf8_unicode_ci NOT NULL,
						title text collate utf8_unicode_ci NOT NULL,
						description text collate utf8_unicode_ci NOT NULL,
						gpr tinyint(4) NOT NULL default '0',
						recip tinyint(4) NOT NULL default '0',
						date date NOT NULL default '0000-00-00',
						size int(32) NOT NULL default '0',
						PRIMARY KEY  (id),
						FULLTEXT KEY pages (url,title,description)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
						";

			mysql_query($sql);

			$sql = "CREATE TABLE search_log (
						id bigint(20) unsigned NOT NULL auto_increment,
						date date NOT NULL default '0000-00-00',
						matches int(11) NOT NULL default '0',
						text text collate utf8_unicode_ci NOT NULL,
						PRIMARY KEY  (id),
						FULLTEXT KEY text (text)
						) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
						";

			mysql_query($sql);

			$r = mysql_query("SHOW TABLE STATUS FROM " . mysql_real_escape_string($_POST['database']) . "");

			$tables = array('bad_keywords', 'banned', 'categories', 'config', 'links', 'new_links',  'pages',  'search_log');

			if(@mysql_num_rows($r)){

				while($array = mysql_fetch_array($r)){

					if(in_array($array[0], $tables)){

						$table_results[] = $array[0];

					}

				}

				if(count($table_results) == count($tables)){

					return array('status'=>true, 'information'=>$table_results);

				}

			}

			return array('status'=>false, 'information'=>'There was an error when creating the MySQL database tables.');

		}

		return array('status'=>false, 'information'=>'I could not connect select the MySQL database. Please check you have access.');

	}

	return array('status'=>false, 'information'=>'I could not connect to the MySQL server. Please check your settings.');

}

?>